#  Exercice 3 p174 Version a completer.
#  Auteur : Laurent Beaussart


def rang_alphabet(lettre):
    """
    Transforme une lettre (chaîne de caractère)
    en nombre (son rang dans l'alphabet)
    
    Paramètres :
    ------------
        lettre : de type chaîne de caractères.
        
    Renvoie :
    ---------
        rang : de type entier
            
    
    """
    
    rang = ord(lettre)-64
    return rang


    
def pas(lettre1, lettre2):
    """
    Calcule le nombre de pas à droite qu'il faut faire pour aller de
    lettre 1 à lettre2
    Exemples : pas('A', 'C') renvoie 3 - 1 donc 2
    
               pas('Z', 'B') renvoie 2 - 26 = -24, mais il faut que ce soit 2
               donc comme -24 < 0 alors on ajoute 26 au résultat
    
    Paramètres :
    ------------
        lettre1 : de type chaîne de caractères.
        lettre2 : de type chaîne de caractères.
        
    Renvoie :
    ---------
        pas : de type entier
            
    
    """    
    
    pas = rang_alphabet(lettre2) - rang_alphabet(lettre1)
    
    if pas < 0 :
        pas = pas + 26
    
    return pas




#   On va avoir besoin de la fonction rendu_de_monnaie du n2 p174 pour la 
#   fonction nb_jours

def rendu_de_monnaie(somme_a_rendre, systeme):
    
    # Initialisation de la somme restante
    somme_restante = somme_a_rendre
    
    
    #  Initialisation de rendu(la liste des nombres de 
    #  billets et pièces par valeurs).
    rendu = [0] * len(systeme)
    
    
    #  i  est l'index de la valeur du p-uplet systeme  qui
    #  est considérée pendant un tour de boucle while externe.
    #  A chaque tour de boucle while externe, i est mis à jour.
    i = 0
    
    while somme_restante != 0:
        #  Calcul de l'index de la valeur de billet ou pièce
        #  à rendre  dans ce tour de boucle while externe.
        while systeme[i] > somme_restante:
            i = i + 1  #  Au dernier tour de cette boucle interne, i a comme
                       #  valeur l'index de la valeur de billet ou pièce
                       #  à rendre maintenant.
        
        #  Calcul du nbre de billets à rendre dans cette valeur.
        rendu[i] = somme_restante // systeme[i]
        
        #  Calcul de la somme restante au début du tour de boucle
        #  externe suivant.
        somme_restante = somme_restante % systeme[i]
        
    return rendu



def evolue_lettre(lettre1, lettre2):
    """
    Calcule le nombre de jours  qu'il faut faire pour aller de
    lettre 1 à lettre2
    Exemples : pas('A', 'C') renvoie 3 - 1 donc 2
    
               pas('Z', 'B') renvoie 2 - 26 = -24, mais il faut que ce soit 2
               donc comme -24 < 0 alors on ajoute 26 au résultat
               
               pas('G', 'T') vaut 13 pas mais renvoie 1 (1 saut de 13 jours)
               
               pas('G', 'U') vaut 14 pas mais renvoie 2 ( 1 saut de 13 jours
               et 1 jour)
               
               Tout se passe comme si pour payer la somme_a_rendre (en nombre
               de pas) il fallait utiliser le système de monnaie (13, 1)
               "billets de 13 et pièces de 1" et compter à la fin les nombres
               de billets et de pièces utilisés qui forment le nombre de jours.

    
    Paramètres :
    ------------
        lettre1 : de type chaîne de caractères.
        lettre2 : de type chaîne de caractères.
        
    Renvoie :
    ---------
        jours : de type entier
            
    
    """    
    
    pass
    
    
    
    
    
    
    
    
    
    
    

#  Test des flèches rouges du dessin p174
assert evolue_lettre('A', 'B') == 1
assert evolue_lettre('A', 'D') == 3
assert evolue_lettre('G', 'L') == 5
assert evolue_lettre('Y', 'H') == 9

#  Test des flèches bleues du dessin p174
assert evolue_lettre('G', 'T') == 1
assert evolue_lettre('W', 'J') == 1




def evolue(mot1, mot2):
    """
    Calcule le nombre de jours  qu'il faut faire pour aller de
    mot1 à mot2
    Exemples : pas('AB', 'BG') renvoie 1 + 5 donc 6
    
               pas('PIG', 'TOC') renvoie 4 + 6 + 10 = 20
               
   On cumule les nombres de jours nécessaires pour évoluer de mot1[i] à mot2[i]
   pour i allant de 0 à longueur(mot1)-1

    
    Paramètres :
    ------------
        mot1 : de type chaîne de caractères.
        mot2 : de type chaîne de caractères.
        
    Renvoie :
    ---------
        jours : de type entier
            
    
    """       

    jours = 0
    for i in range (len(mot1)):
        jours= jours + evolue_lettre(mot1[i], mot2[i])
        
    return jours


#  Test du nombre de jours pour évoluer de 'AB' à 'BG'
assert evolue('AB', 'BG') == 6

#  Test du nombre de jours pour évoluer de 'PIG' à 'TOC'
assert evolue('PIG', 'TOC') == 20

